function [ px, py, pz ] = LLA2NAV( point_lla,ref_point_lla, psi)
% LLA2NED Summary of this function goes here
%   Detailed explanation goes here
Rot = [cosd(psi) -sind(psi);
    sind(psi) cosd(psi)];

flattening = 1/298.257223563;
R_eq = 6378137;

R_N = R_eq / sqrt(1 - (2*flattening-flattening^2)*(sind(ref_point_lla(1)))^2);
R_M = R_N * ((1-(2*flattening - flattening^2))/(1 - (2*flattening - flattening^2)*(sind(ref_point_lla(1))))^2);

dlat = point_lla(1) - ref_point_lla(1);
dlong = point_lla(2) - ref_point_lla(2);

dN = dlat / (atand(1/R_M));
dE = dlong / (atand(1/(R_N * cosd(ref_point_lla(1)))));

v = Rot * [dN, dE]';
px = v(1);
py = v(2);
pz = -point_lla(3) + ref_point_lla(3);
end

