function [ lat, long, h ] = NAV2LLA( point_ned, ref_point_lla, psi)
% NED2LLA Summary of this function goes here
%   Detailed explanation goes here
Rot = [cosd(psi) -sind(psi);
    sind(psi) cosd(psi)];
v = Rot * point_ned(1:2);

flattening = 1/298.257223563;
R_eq = 6378137;

R_N = R_eq / sqrt(1 - (2*flattening-flattening^2)*(sind(ref_point_lla(1)))^2);
R_M = R_N * ((1-(2*flattening - flattening^2))/(1 - (2*flattening - flattening^2)*(sind(ref_point_lla(1))))^2);

dlat = atand(1/R_M)* v(1);
dlong = atand(1/(R_N*cosd(ref_point_lla(1))))*v(2);

lat = ref_point_lla(1) + dlat;
long = ref_point_lla(2) + dlong;
h = - point_ned(3) + ref_point_lla(3);
end
