function [ ddx1,ddy1,ddx2,ddy2,ddx3,ddy3,ddx4,ddy4 ] = find_pixels( z_in ,width,height,r_w,r_h)
%UNTITLED3 Summary of this function goes here
%   Detailed explanation goes here

x = 0;
y = 0;
z = -z_in;
roll = 0;
pitch = 0;
yaw = 90;

%%

pos_uav_ned = [x,y,z]';
rc = pos_uav_ned;

alfa = 45;

W = 27/2;
H = 35/2;
tW = tand(W);
tH = tand(H);

% camrea frame:
C_c = [0,0, -(1/2)*z]';
c = abs(C_c(3));

% cam 2 body
% Ry(alfa) * Rz(yaw)
Ry = [cosd(alfa),0,sind(alfa);
    0,1,0;
    -sind(alfa),0,cosd(alfa)];
Rz = [cosd(yaw),-sind(yaw),0;
    sind(yaw),cosd(yaw),0;
    0,0,1];

T = Rz * Ry;

FS_c = [c*tW, c*tH, c]';
FP_c = [c*tW, -c*tH, c]';
RS_c = [-c*tW, c*tH, c]';
RP_c = [-c*tW, -c*tH, c]';

C_p = T * C_c + rc;
FS_p = T * FS_c + rc;
FP_p = T * FP_c + rc;
RS_p = T * RS_c + rc;
RP_p = T * RP_c + rc;


% center point
deltaC_x = C_p(1) - rc(1);
deltaC_y = C_p(2) - rc(2);
deltaC_z = C_p(3) - rc(3);

t = -rc(3)/deltaC_z;
cp =[rc(1)+deltaC_x*t, rc(2)+deltaC_y*t,rc(3)+deltaC_z*t]';


% FS
deltaFS = FS_p - rc;
t = -rc(3)/deltaFS(3);
fs = [rc(1)+deltaFS(1)*t,rc(2)+deltaFS(2)*t,rc(3)+deltaFS(3)*t]';



% FP
deltaFP = FP_p - rc;

t = -rc(3)/deltaFP(3);
fp = [rc(1)+deltaFP(1)*t,rc(2)+deltaFP(2)*t,rc(3)+deltaFP(3)*t];


% RS
deltaRS = RS_p - rc;
t = -rc(3)/deltaRS(3);
rs = [rc(1)+deltaRS(1)*t,rc(2)+deltaRS(2)*t,rc(3)+deltaRS(3)*t]';


% RP
deltaRP = RP_p - rc;
t = -rc(3)/deltaRP(3);
rp = [rc(1)+deltaRP(1)*t,rc(2)+deltaRP(2)*t,rc(3)+deltaRP(3)*t]';

% % calculate area covered
% b1 = abs(fs(1)-fp(1));
% b2 = abs(rs(1)-rp(1));
% h = abs(fs(2) - rs(2));
% 
% A = 0.5 * h * (b1+b2);

%% person 1
wi = width;
zp1 = -height;

xp1 = cp(1) + wi/2;
yp1 = cp(2) + r_h;



nv1 = [xp1-wi,yp1,0]';
nh1 = [xp1,yp1,0]';
ov1 = [xp1-wi,yp1,zp1]';
oh1 = [xp1,yp1,zp1]';

X_p1 = [nv1(1),nh1(1),oh1(1),ov1(1)]';
Y_p1 = [nv1(2),nh1(2),oh1(2),ov1(2)]';
Z_p1 = [nv1(3),nh1(3),oh1(3),ov1(3)]';

%% person 2
zp2 = -height;
xp2 = cp(1)+ wi/2;
yp2 = cp(2)-r_w;

nv2 = [xp2-.5,yp2,0]';
nh2 = [xp2,yp2,0]';
ov2 = [xp2-.5,yp2,zp2]';
oh2 = [xp2,yp2,zp2]';

X_p2 = [nv2(1),nh2(1),oh2(1),ov2(1)]';
Y_p2 = [nv2(2),nh2(2),oh2(2),ov2(2)]';
Z_p2 = [nv2(3),nh2(3),oh2(3),ov2(3)]';

%% person 3

zp3 = -height;
xp3 = cp(1) -r_w+ wi/2;
yp3 = cp(2);

nv3 = [xp3-.5,yp3,0]';
nh3 = [xp3,yp3,0]';
ov3 = [xp3-.5,yp3,zp3]';
oh3 = [xp3,yp3,zp3]';

X_p3 = [nv3(1),nh3(1),oh3(1),ov3(1)]';
Y_p3 = [nv3(2),nh3(2),oh3(2),ov3(2)]';
Z_p3 = [nv3(3),nh3(3),oh3(3),ov3(3)]';

%% person 4
zp4 = -height;

xp4 = cp(1)+r_w + wi/2;
yp4 = cp(2);

nv4 = [xp4-.5,yp4,0]';
nh4 = [xp4,yp4,0]';
ov4 = [xp4-.5,yp4,zp4]';
oh4 = [xp4,yp4,zp4]';

X_p4 = [nv4(1),nh4(1),oh4(1),ov4(1)]';
Y_p4 = [nv4(2),nh4(2),oh4(2),ov4(2)]';
Z_p4 = [nv4(3),nh4(3),oh4(3),ov4(3)]';

%%

hit_x1 = [];
hit_y1 = [];
hit_x2 = [];
hit_y2 = [];
hit_x3 = [];
hit_y3 = [];
hit_x4 = [];
hit_y4 = [];

for i = 1:512 
    for j = 1:640
        dx = (i/512) * 2 * tW * c;      % H > W
        dy = (j/640) * 2 * tH * c;
        point_c = RP_c + [dx,dy,0]';    % rp = lysebl
        
        point_p = T * point_c + rc;
        deltaPoint = point_p - rc;
        % person 1
        t = (nv1(2) - rc(2))/deltaPoint(2);
        P = [rc(1)+deltaPoint(1)*t,rc(2)+deltaPoint(2)*t,rc(3)+deltaPoint(3)*t]';
        
        %P = P_p * t;
        if P(1) >nv1(1) && P(1) < nh1(1)
            if P(3) < 0 && P(3) > ov1(3)
                hit_x1 = [hit_x1; i];
                hit_y1 = [hit_y1; j];          
            end
        end
        
        %person 2
        t = (nv2(2) - rc(2))/deltaPoint(2);
        
        %P = P_p*t;
        P = [rc(1)+deltaPoint(1)*t,rc(2)+deltaPoint(2)*t,rc(3)+deltaPoint(3)*t]';
        if P(1) >nv2(1) && P(1) < nh2(1)
            if P(3) < 0 && P(3) > ov2(3)
                hit_x2 = [hit_x2; i];
                hit_y2 = [hit_y2; j];
            end
        end
        
        % person 3
        t = (nv3(2) - rc(2))/deltaPoint(2);
        
        %P = P_p*t;
        P = [rc(1)+deltaPoint(1)*t,rc(2)+deltaPoint(2)*t,rc(3)+deltaPoint(3)*t]';
        if P(1) >nv3(1) && P(1) < nh3(1)
            if P(3) < 0 && P(3) > ov3(3)
                hit_x3 = [hit_x3; i];
                hit_y3 = [hit_y3; j];
            end
        end
        
        % person 4
        t = (nv4(2) - rc(2))/deltaPoint(2);
        
        %P = P_p*t;
        P = [rc(1)+deltaPoint(1)*t,rc(2)+deltaPoint(2)*t,rc(3)+deltaPoint(3)*t]';
        if P(1) >nv4(1) && P(1) < nh4(1)
            if P(3) < 0 && P(3) > ov4(3)
                hit_x4 = [hit_x4; i];
                hit_y4 = [hit_y4; j];
            end
        end
    end
end

ddx1 = max(hit_x1) - min(hit_x1) +1;
ddy1 = max(hit_y1) - min(hit_y1) +1;


figure(1), clf
plot3(y,x,z,'x'); hold on;
plot3(fs(2),fs(1),fs(3),'ob');
plot3(fp(2),fp(1),fp(3),'ok');
plot3(rs(2),rs(1),rs(3),'om');
plot3(rp(2),rp(1),rp(3),'oc');
line([rp(2) rs(2) fs(2) fp(2) rp(2)],[rp(1) rs(1) fs(1) fp(1) rp(1)],[rp(3) rs(3) fs(3) fp(3) rp(3)],'Color','r')
line([RP_p(2) RS_p(2) FS_p(2) FP_p(2) RP_p(2)],[RP_p(1) RS_p(1) FS_p(1) FP_p(1) RP_p(1)],[RP_p(3) RS_p(3) FS_p(3) FP_p(3) RP_p(3)],'Color','g')
set(gca,'ZDir','Reverse')
%fill3(Y,X,Z,'g');
%fill3(Y_pro,X_pro,Z_pro,'g');
fill3(Y_p1,X_p1,Z_p1,'b');
fill3(Y_p2,X_p2,Z_p2,'m');
fill3(Y_p3,X_p3,Z_p3,'c');
fill3(Y_p4,X_p4,Z_p4,'k');

x_o = ddx1;
y_o = ddy1;
ddx2 = max(hit_x2) - min(hit_x2) +1;
ddy2 = max(hit_y2) - min(hit_y2) +1;
ddx3 = max(hit_x3) - min(hit_x3) +1;
%ddy3 = max(hit_y3) - min(hit_y3) +1
ddy3=0;
for i = 1:length(hit_y3)
    if hit_x3(i) == max(hit_x3)
        ddy3 = ddy3+1;
    end
end
ddx4 = max(hit_x4) - min(hit_x4) +1;
%ddy4 = max(hit_y4) - min(hit_y4) +1
ddy4 = 0;
for i = 1:length(hit_y4)
    if hit_x4(i) == max(hit_x4)
        ddy4 = ddy4+1;
    end
end



figure(2),clf        % m roteres 180 grader om det skal se riktig ut siden origio er i fs.
plot(hit_y1,hit_x1,'x');
hold on;
plot(hit_y2,hit_x2,'xm')
plot(hit_y3,hit_x3,'xc')
plot(hit_y4,hit_x4,'xk')
axis([0 640 0 512])
grid on;

end

