function [ even_newer_waypoints,distance_3,distance_0 ] = cover_area( p_area )
%COVER_AREA Summary of this function goes here
%   Detailed explanation goes here
%% Define area by points
%x_area = [0,120,100,200,10,20]';
%y_area = [0,10,80,200,190,101]';        % fr en feil nr =80 => en new virtual line intersecter med 3 linjer

x_area = p_area(:,1);
y_area = p_area(:,2);


%% Create box around area


x_box_min = min(x_area);
x_box_max = max(x_area);
y_box_min = min(y_area);
y_box_max = max(y_area);

x_box = [x_box_min, x_box_max, x_box_max, x_box_min]';
y_box = [y_box_min, y_box_min, y_box_max, y_box_max];


%% calculate waypoints
start_point = [x_box_min, y_box_min]';
W_shape = y_box_max-y_box_min;
%W_camera = 40 * tand(35);
W_camera = 20;
%number of rounds
n_r = W_shape / (W_camera * 2);
nr = ceil(n_r);

W_round = W_shape / nr;
waypoints = zeros(2*nr,2);
for i = 1:2*nr
    if i == 1
        wp = start_point + W_round/2 * [0,1]';
    elseif mod(i,2) == 1
        wp = waypoints(i-1,:)' + W_round * [0,1]';
    else
        if waypoints(i-1,1) == x_box_min
            wp = [x_box_max,waypoints(i-1,2)]';
        else
            wp = [x_box_min,waypoints(i-1,2)]';
        end
    end
    waypoints(i,:) = wp';
end
%waypoints = [0,0; 
%    waypoints];


%% cut the vertical lines at the shapes edges
[n_wp,m_wp] = size(waypoints);
new_waypoints = zeros(n_wp,m_wp);
for i = 1:2: length(waypoints)
    % find a vertical line between two waypoints 1&2, 3&4 5&6 etc
    a = waypoints(i,:)';
    b = waypoints(i+1,:)';
    
    i1 = zeros(2,1);
    i2 = zeros(2,1);
    i_points = [];
    % find the two area lines that collides with the line
    for j = 1: length(p_area)
        p1 = p_area(j,:)';
        if  j == length(p_area)
            p2 = p_area(1,:)';
        else
            p2 = p_area(j+1,:)';
        end
        
        
        % vet a og b har samme y-verdi
        if (p1(2) >= a(2) && p2(2) <= a(2)) || (p1(2) <= a(2) && p2(2) >= a(2))
            % intersection
            
            % lag parameterfremstilling
            deltap = p2-p1;
            P = @(t) (p1 + t * deltap);
            t = (a(2) - p1(2)) / deltap(2);
            
            p_i = P(t);
            i_points= [i_points;
                p_i'];

        end
    end
    [x,i_max] = max(i_points(:,1));
    [x,i_min] = min(i_points(:,1));
    
    i1 = i_points(i_max,:)';
    i2 = i_points(i_min,:)';
    
    
    % bytt ut i1,i2 med de riktig waypointene
    if a(1) >  b(1) % a verst
        if i1(1) > i2(1)
            new_waypoints(i,:) = i1';
            new_waypoints(i+1,:) = i2';
        else
            new_waypoints(i,:) = i2';
            new_waypoints(i+1,:) = i1';
        end
    else
        if i1(1) > i2(1)
            new_waypoints(i+1,:) = i1';
            new_waypoints(i,:) = i2';
        else
            new_waypoints(i+1,:) = i2';
            new_waypoints(i,:) = i1';
        end
    end
    
end

% figure(2),clf
% plot(y_area,x_area,'o');
% hold on;
% line(y_area,x_area);
% line([y_area(length(y_area)) y_area(1)],[x_area(length(x_area)) x_area(1)]);
% plot(new_waypoints(:,2),new_waypoints(:,1),'og'); 
% line(new_waypoints(:,2),new_waypoints(:,1),'Color','g');

%% Add virtual lines
%virtual_lines = zeros(n_wp-2,m_wp);
virtual_lines = new_waypoints(1:end,:) + 0.5*W_round * [zeros(n_wp,1) ones(n_wp,1)];
new_virtual_lines = virtual_lines;

% figure(2)
% plot(new_virtual_lines(:,2),new_virtual_lines(:,1),'xr');
% for i = 1:2:length(new_virtual_lines)
%     line([new_virtual_lines(i,2),new_virtual_lines(i+1,2)],[new_virtual_lines(i,1),new_virtual_lines(i+1,1)],'Color','r');
% end
for i = 1:2:length(virtual_lines)-2
    
    % find a vertical line between two waypoints 1&2, 3&4 5&6 etc
    a = virtual_lines(i,:)';
    b = virtual_lines(i+1,:)';
    
    i1 = zeros(2,1);
    i2 = zeros(2,1);
    i_points = [];
    % find the two area lines that collides with the line
    for j = 1: length(p_area)
        p1 = p_area(j,:)';
        if  j == length(p_area)
            p2 = p_area(1,:)';
        else
            p2 = p_area(j+1,:)';
        end
        
        
        % vet a og b har samme y-verdi
        if (p1(2) >= a(2) && p2(2) <= a(2)) || (p1(2) <= a(2) && p2(2) >= a(2))
            % intersection
            
            % lag parameterfremstilling
            deltap = p2-p1;
            P = @(t) (p1 + t * deltap);
            t = (a(2) - p1(2)) / deltap(2);
            
            p_i = P(t);
            i_points = [i_points;
                p_i'];
        end
    end
    [x,i_max] = max(i_points(:,1));
    [x,i_min] = min(i_points(:,1));
    
    i1 = i_points(i_max,:)';
    i2 = i_points(i_min,:)';
    
    % bytt ut i1,i2 med de riktig waypointene
    if a(1) >  b(1) % a verst
        if i1(1) > i2(1)
            new_virtual_lines(i,:) = i1';
            new_virtual_lines(i+1,:) = i2';
        else
            new_virtual_lines(i,:) = i2';
            new_virtual_lines(i+1,:) = i1';
        end
    else
        if i1(1) > i2(1)
            new_virtual_lines(i+1,:) = i1';
            new_virtual_lines(i,:) = i2';
        else
            new_virtual_lines(i+1,:) = i2';
            new_virtual_lines(i,:) = i1';
        end
    end
    
end


%% check if waypoints must be fixed
% if the new virtual line x coordinate in line i - i+1 > waypoint x in line i - 1+i /
% i+2 - i or smaller for the south waypoint
newer_waypoints = new_waypoints;

for i = 1:2:length(new_virtual_lines)
    a = new_virtual_lines(i,:)';
    b = new_virtual_lines(i+1,:)';
    
    if i < length(new_virtual_lines)-1
        for j = 0:2:3   % j = 0 , j = 2
            x1 = new_waypoints(i+j,1);
            x2 = new_waypoints(i+j+1,1);
            
            if a(1) > b(1)
                if x1> x2
                    if a(1) > x1
                        newer_waypoints(i+j,1) = a(1);
                    elseif b(1) < x2
                        newer_waypoints(i+j+1,1) = b(1);
                    end
                else %x2 > x1
                    if a(1) > x2
                        newer_waypoints(i+j+1,1) = a(1);
                    elseif b(1) < x1
                        newer_waypoints(i+j,1) = b(1);
                    end
                end
            else
                if x1> x2
                    if b(1) > x1
                        newer_waypoints(i+j,1) = b(1);
                    elseif a(1) < x2
                        newer_waypoints(i+j+1,1) = a(1);
                    end
                else %x2 > x1
                    if b(1) > x2
                        newer_waypoints(i+j+1,1) = b(1);
                    elseif a(1) < x1
                        newer_waypoints(i+j,1) = a(1);
                    end
                end
                
            end
        end
    else
        x1 = new_waypoints(i,1);
        x2 = new_waypoints(i+1,1);
        if a(1) > b(1)
            if x1> x2
                if a(1) > x1
                    newer_waypoints(i,1) = a(1);
                elseif b(1) < x2
                    newer_waypoints(i+1,1) = b(1);
                end
            else %x2 > x1
                if a(1) > x2
                    newer_waypoints(i+1,1) = a(1);
                elseif b(1) < x1
                    newer_waypoints(i,1) = b(1);
                end
            end
        else
            if x1> x2
                if b(1) > x1
                    newer_waypoints(i,1) = b(1);
                elseif a(1) < x2
                    newer_waypoints(i+1,1) = a(1);
                end
            else %x2 > x1
                if b(1) > x2
                    newer_waypoints(i+1,1) = b(1);
                elseif a(1) < x1
                    newer_waypoints(i,1) = a(1);
                end
            end         
        end       
    end
end

%% algorithm 6
% dersom et hjrne av omrdet er mellom 2 wp kan det havne utenfor, dette
% fikses her

% 1 find lines between waypoints
% line: y = ax + b
% a = zeros(length(newer_waypoints)-1,1);
% b = zeros(length(newer_waypoints)-1,1);
% c = zeros(length(newer_waypoints)-1,1);
% 
% for i = 1:length(newer_waypoints)-1
%     a(i) = newer_waypoints(i,2) - newer_waypoints(i+1,2);
%     b(i) = newer_waypoints(i+1,1) - newer_waypoints(i,1);
%     c(i) = newer_waypoints(i,1)*newer_waypoints(i+1,2) - newer_waypoints(i+1,1)*newer_waypoints(i,2);
% end

additional_waypoints = [];
even_newer_waypoints = newer_waypoints;

for i = 1:length(p_area)
    d = zeros(length(newer_waypoints)-1,1);
    
    for j = 1:length(newer_waypoints)-1
        finish = 0;
        P0 = newer_waypoints(j,:)';
        P1 = newer_waypoints(j+1,:)';
        P = p_area(i,:)';
        
        v = P1-P0;
        w = P-P0;
        
        c1 = dot(w,v);
        if c1 <=0 && finish == 0% before P0
            d(j) = sqrt((P(1)-P0(1))^2+(P(2)-P0(2))^2);
            finish = 1;
        end
        c2 = dot(v,v);
        if c2 <= c1 && finish == 0% after P1
            d(j) = sqrt((P(1)-P1(1))^2+(P(2)-P1(2))^2);
            finish = 1;
        end
        b1 = c1/c2;
        Pb = P0 + b1*v;
        if finish == 0
            d(j) = sqrt((P(1)-Pb(1))^2+(P(2)-Pb(2))^2);
        end
        
        
        
%         d(j) = abs(a(j) * p_area(i,1) + b(j) * p_area(i,2) + c(j))/ ...
%             sqrt(a(j)^2 + b(j)^2);
    end
    if min(d) > W_camera
        % OK
        % add new waypoint between in line
        [d_min,i_min] = min(d);
        k = 1;
        while k < length(even_newer_waypoints)
            y = even_newer_waypoints(k,2);
            x1 = even_newer_waypoints(k,1);
            x2 = even_newer_waypoints(k+1,1);
            
            if abs(P(2)- y) < W_camera
                if x1 > x2
                    if P(1) > x1
                        even_newer_waypoints(k,1) = P(1);
                    elseif P(1) < x2
                        even_newer_waypoints(k+1,1) = P(1);
                    end
                else
                    if P(1) > x2
                        even_newer_waypoints(k+1,1) = P(1);
                    elseif P(1) < x1
                        even_newer_waypoints(k,1) = P(1);
                    end
                end
            end
            
            
            
            k = k+2;
        end

    end
    
end


% reduce with H_camera
H_camera = 0;
for i= 1:2:length(even_newer_waypoints)
    if even_newer_waypoints(i,1)> even_newer_waypoints(i+1,1)
        even_newer_waypoints(i,1) = even_newer_waypoints(i,1) - H_camera;
        even_newer_waypoints(i+1,1) = even_newer_waypoints(i+1,1) + H_camera;
    else
        even_newer_waypoints(i,1) = even_newer_waypoints(i,1) + H_camera;
        even_newer_waypoints(i+1,1) = even_newer_waypoints(i+1,1) - H_camera;
    end
    
%     if even_newer_waypoints(i,1)> 0
%         even_newer_waypoints(i,1) = even_newer_waypoints(i,1) - H_camera;
%     else
%         even_newer_waypoints(i,1) = even_newer_waypoints(i,1) + H_camera;
%     end
end

%% calculate distance
distance_0 = 0; %distanse dekket box
distance_1 = 0; % distance etter  ha kuttet linjene ned til  krasje med area linjene
distance_2 = 0; % distance etter  ha lagt til virtuelle linje og endret wps
distance_3 = 0; % distanse etter ha lagt til ekstra waypoints

for i = 1: length(waypoints)-1
    distance_0 = distance_0 + sqrt((waypoints(i+1,1)-waypoints(i,1))^2+(waypoints(i+1,2)-waypoints(i,2))^2);
    distance_1 = distance_1 + sqrt((new_waypoints(i+1,1)-new_waypoints(i,1))^2+(new_waypoints(i+1,2)-new_waypoints(i,2))^2);
    distance_2 = distance_2 + sqrt((newer_waypoints(i+1,1)-newer_waypoints(i,1))^2+(newer_waypoints(i+1,2)-newer_waypoints(i,2))^2);
end
for i = 1: length(even_newer_waypoints)-1
    distance_3 = distance_3 + sqrt((even_newer_waypoints(i+1,1)-even_newer_waypoints(i,1))^2+(even_newer_waypoints(i+1,2)-even_newer_waypoints(i,2))^2);
end


end

