clear all;
close all;

x_area = 2.5*[40,160,40,130,40, 10,0,-20,0,-10,-40,10,30]';
y_area = [0,40,80,120,160,200,200,140,120,110,90,70,30 ]';

p_area = [x_area, y_area];

p_area_rot = p_area;
N = 180-1;
results = zeros(N,3);

figure(1), clf
plot(y_area,x_area,'o');
hold on;
line(y_area,x_area);
line([y_area(length(y_area)) y_area(1)],[x_area(length(x_area)) x_area(1)]);
title('The area to be covered');
xlabel('Distance East [meters]');
ylabel('Distance North [meters]');
%hgexport(1,'area_v2');

for theta = 0:1:N
    R = [cosd(-theta),-sind(-theta);
        sind(-theta),cosd(-theta)];
    for i = 1:length(p_area)
        p_area_rot(i,:) = (R * p_area(i,:)')';
    end
    
    [waypoints,distance,distance_LM] = cover_area(p_area_rot);
    results(theta+1,:) = [theta,distance,distance_LM];
end

[best_distance,i] = min(results(:,2));
best_theta = i - 1;

%% find the best waypoints
[best_distance,i] = min(results(:,2));
best_theta = i - 1
p_area_best_rot = p_area;
R = [cosd(-best_theta),-sind(-best_theta);
        sind(-best_theta),cosd(-best_theta)];
for i = 1:length(p_area)
        p_area_best_rot(i,:) = (R * p_area(i,:)')';
end
[waypoints_best,distance,distance_LM] = cover_area(p_area_best_rot);

R2 = [cosd(best_theta),-sind(best_theta);
        sind(best_theta),cosd(best_theta)];
for j = 1:length(waypoints_best)
    waypoints_best(j,:) = (R2 * waypoints_best(j,:)')';
end

figure(21), clf
plot(y_area,x_area,'o');
hold on;
line(y_area,x_area);
line([y_area(length(y_area)) y_area(1)],[x_area(length(x_area)) x_area(1)]);
title('The path with the shortest search distance');
xlabel('Distance East [meters]');
ylabel('Distance North [meters]');
plot(waypoints_best(:,2),waypoints_best(:,1),'og'); 
line(waypoints_best(:,2),waypoints_best(:,1),'Color','g');
%axis([-50 250 -100 500])
    
 %% find the worst waypoints
[worst_distance,i] = max(results(:,2));
worst_theta = i - 1

p_area_worst_rot = p_area;
R = [cosd(-worst_theta),-sind(-worst_theta);
        sind(-worst_theta),cosd(-worst_theta)];
for i = 1:length(p_area)
        p_area_worst_rot(i,:) = (R * p_area(i,:)')';
end
[waypoints_worst,distance,distance_LM] = cover_area(p_area_worst_rot);

R2 = [cosd(worst_theta),-sind(worst_theta);
        sind(worst_theta),cosd(worst_theta)];
for j = 1:length(waypoints_worst)
    waypoints_worst(j,:) = (R2 * waypoints_worst(j,:)')';
end

figure(22), clf
plot(y_area,x_area,'o');
hold on;
line(y_area,x_area);
line([y_area(length(y_area)) y_area(1)],[x_area(length(x_area)) x_area(1)]);
title('The path with the longest search distance');
xlabel('Distance East [meters]');
ylabel('Distance North [meters]');
plot(waypoints_worst(:,2),waypoints_worst(:,1),'og'); 
line(waypoints_worst(:,2),waypoints_worst(:,1),'Color','g');
%axis([0 200 -100 400])

%hgexport(21,'path_rot_best');
%hgexport(22,'path_rot_worst');

%% plot
figure(10),clf
plot(results(:,1),results(:,2));
hold on;
plot(results(:,1),results(:,3),'r');
legend('Adjusted pattern','Lawnmower pattern')
ylabel('Search distance [meters]');
xlabel('rotation [degrees]');
title('Search distance with different rotations')
%hgexport(10,'results_with_rotations')

% figure(12),clf
% plot(results(:,1),results(:,3));
% ylabel('distance lawnmower pattern [meters]');
% xlabel('rotation [degrees]');
% title('Distance of lawnmower pattern with different rotations')