close all;
clear all;
% test av model:test_setup

CSP = [0,0]';
S = 40-1;

dist = 400; 
h = 0;  % to start i right point when using barrier patrol
start_point = CSP;
% VALG AV Mnster
m = 1;


sim_time =1;
sample_time = 1;
speed = 5;

switch m
    case 1
        waypoints = parallel_search( CSP, S, dist,dist);
        sim_time = 985;
    case 2
        waypoints = creeping_line_search( CSP, S, dist,dist);
        sim_time = 985;
    case 3
        %CSP = [100,100]';
        waypoints = square_search( CSP, S,dist);
        sim_time = 480;
    case 4
        %CSP = [100,100]';
        waypoints = sector_search( CSP,dist, 3);
        sim_time = 539;
    case 5
        %CSP = [100,100]';
        waypoints = barrier_patrol_search( CSP,dist);
        h = dist/2;
        start_point = [waypoints(1,1),waypoints(1,2)]';
        sim_time = 610;
        % for this pattern, R in the guidance system must be increase from
        % 10 to 40. And Rk must be increased dependent on the simulation
        % speed. Otherwise matlab will give an error.
end

%waypoints = flipud(waypoints);
%start_point = [waypoints(1,1),waypoints(1,2)]';



%find distance
search_distance = 0;
for i = 1:length(waypoints)-1
    search_distance = search_distance + sqrt((waypoints(i+1,1)-waypoints(i,1))^2 + (waypoints(i+1,2)-waypoints(i,2))^2 );
end
search_distance


%% simulation

sim('test_setup');

t = 1:9:length(position);
plot_position =position(t,:);
% plots
figure(1),clf
plot(waypoints(:,2),waypoints(:,1),'or');
hold on;
line(waypoints(:,2),waypoints(:,1),'Color','r');
plot(position(:,2),position(:,1),'xk');





%% stationary subjects
% stat_sub = zeros(20,2);
% for i = 1:length(stat_sub)
% %     stat_sub(i,1) = CSP(1) + (mod(i,10)+ 1) * rand() * 10;
% %     stat_sub(i,2) = CSP(2) + (mod(i,10)+ 1) * rand() * 10;
%     
%     stat_sub(i,1) = CSP(1) + 200 * rand();
%     stat_sub(i,2) = CSP(2) + 200 * rand();
% end
load('stationary_targets_200.mat')
figure(1)
plot(stat_sub(:,2),stat_sub(:,1),'ob');
%legend('Subject')
% matlab2tikz('sim_barrier.tikz','height','\figureheight','width','\figurewidth');
% cleanfigure; 
% matlab2tikz('sim_barrier.tex','height','\figureheight','width','\figurewidth');

%% check if subject is captured by a camera frame
N = length(stat_sub);
M = length(position);
r = (S+1)/2;
captured = zeros(N,1);
for i = 1:N
    for j = 1:M
        position_cam = position(j,:)' + 50*[cosd(psi_d(j)),sind(psi_d(j))]';
        d = (position_cam(1)-stat_sub(i,1))^2 + (position_cam(2)-stat_sub(i,2))^2;
        if d < r^2
            captured(i) = 1;
        end
    end
end

sum(captured)





%% Test av area coverage
M = length(position);
r = (S+1)/2;
resolution =50;
dx = dist/resolution;

area_coverage_m = zeros(resolution);
if m == 1 || m == 2
    for i = 1:resolution        % x-coord
        for j = 1:resolution    % y-coord
            for k = 1:M         % position
                d_a = (position(k,1) + (50*cosd(psi_d(k))) -i*dx)^2 + (position(k,2) + (50*sind(psi_d(k))) -j*dx)^2;
                
                if d_a < r^2
                    area_coverage_m(i,j)=1;
                end
            end
        end
    end
else
    for i = 1:resolution        % x-coord
        for j = 1:resolution    % y-coord
            for k = 1:M         % position
                d_a = (position(k,1) + (50*cosd(psi_d(k)))-(CSP(1)-dist/2 + i*dx))^2 + (position(k,2) + (50*sind(psi_d(k)))-(CSP(2)-dist/2 + j*dx))^2;
                
                if d_a < r^2
                    area_coverage_m(i,j)=1;
                end
            end
        end
    end
end
% 
%coverage in percent
perc = (sum(area_coverage_m(:))/resolution^2) * 100
% 
% 
%% plot
figure(2),clf
hold on;
if m == 1 || m == 2
    for i = 1:resolution
        for j = 1:resolution
            if area_coverage_m(i,j) ==1
                plot(j*dx,i*dx,'xk');
                %plot(j*dx,i*dx,'.','markersize',20)
                
            end
        end
    end
else
    for i = 1:resolution
        for j = 1:resolution
            if area_coverage_m(i,j) ==1
                
                plot((CSP(2)-dist/2 + j*dx),(CSP(1)-dist/2 + i*dx),'xb');
                
            end
        end
    end
end



