close all;
clear all;
% test av model:test_setup

CSP = [0,0]';
S = 40-1;

dist = 400; 
h = 0;  % to start i right point when using barrier patrol
start_point = CSP;
% VALG AV Mnster
m = 3;


sim_time =1;
sample_time = 1;
speed = 5;

switch m
    case 1
        waypoints = parallel_search( CSP, S, dist,dist);
        sim_time = 985;
    case 2
        waypoints = creeping_line_search( CSP, S, dist,dist);
        sim_time = 985;
    case 3
        %CSP = [100,100]';
        waypoints = square_search( CSP, S,dist);
        sim_time = 480;
    case 4
        %CSP = [100,100]';
        waypoints = sector_search( CSP,dist, 3);
        sim_time = 539;
    case 5
        %CSP = [100,100]';
        waypoints = barrier_patrol_search( CSP,dist);
        h = dist/2;
        start_point = [waypoints(1,1),waypoints(1,2)]';
        sim_time = 610;
        % for this pattern, R in the guidance system must be increase from
        % 10 to 40. And Rk must be increased dependent on the simulation
        % speed. Otherwise matlab will give an error.
end


%% SIM
sim('test_setup');


%% load the moving subjects
load('sub1.mat');
load('sub2.mat');
load('sub3.mat');
load('sub4.mat');

%% check if captured by a frame
N = min(length(position),length(position_sub1));
found = zeros(4,1);
r = 20;

for i = 1:N
    
    position_cam = position(i,:)' + 50*[cosd(psi_d(i)),sind(psi_d(i))]';
    %d = (position_cam-stat_sub(i,1))^2 + (position_cam-stat_sub(i,2))^2;
    d1 = (position_cam(1)-position_sub1(i,1))^2 + (position_cam(2)-position_sub1(i,2))^2;
    d2 = (position_cam(1)-position_sub2(i,1))^2 + (position_cam(2)-position_sub2(i,2))^2;
    d3 = (position_cam(1)-position_sub3(i,1))^2 + (position_cam(2)-position_sub3(i,2))^2;
    d4 = (position_cam(1)-position_sub4(i,1))^2 + (position_cam(2)-position_sub4(i,2))^2;
    
    if d1 < r^2
        found(1) = 1;
    end
    if d2 < r^2
        found(2) = 1;
    end
    if d3 < r^2
        found(3) = 1;
    end
    if d4 < r^2
        found(4) = 1;
    end
end
found


%% PLOT
figure(1),clf
plot(waypoints(:,2),waypoints(:,1),'or');
hold on;
line(waypoints(:,2),waypoints(:,1),'Color','r');
plot(position(:,2),position(:,1),'xk');
plot(position_sub1(:,2),position_sub1(:,1),'r','LineWidth',4);
plot(position_sub2(:,2),position_sub2(:,1),'m','LineWidth',4);
plot(position_sub3(:,2),position_sub3(:,1),'b','LineWidth',4);
plot(position_sub4(:,2),position_sub4(:,1),'y','LineWidth',4);
xlabel('Distance East [m]');
ylabel('Distance North [m]')
%xlim([-50 dist])

% matlab2tikz('mov_parallel.tikz','height','\figureheight','width','\figurewidth');
% cleanfigure('minimumPointsDistance',5);
% matlab2tikz('mov_parallel.tex','height','\figureheight','width','\figurewidth');

% matlab2tikz('mov_creeping.tikz','height','\figureheight','width','\figurewidth');
% cleanfigure('minimumPointsDistance',5); 
% matlab2tikz('mov_creeping.tex','height','\figureheight','width','\figurewidth');
% 
% matlab2tikz('mov_square.tikz','height','\figureheight','width','\figurewidth');
% cleanfigure('minimumPointsDistance',5); 
% matlab2tikz('mov_square.tex','height','\figureheight','width','\figurewidth');
% 
% matlab2tikz('mov_sector.tikz','height','\figureheight','width','\figurewidth');
% cleanfigure('minimumPointsDistance',5); 
% matlab2tikz('mov_sector.tex','height','\figureheight','width','\figurewidth');
% 
% matlab2tikz('mov_barrier.tikz','height','\figureheight','width','\figurewidth');
% cleanfigure('minimumPointsDistance',5); 
% matlab2tikz('mov_barrier.tex','height','\figureheight','width','\figurewidth');