/*
 * Copyright (c) 2004-2014 Universidade do Porto - Faculdade de Engenharia
 * Laboratório de Sistemas e Tecnologia Subaquática (LSTS)
 * All rights reserved.
 * Rua Dr. Roberto Frias s/n, sala I203, 4200-465 Porto, Portugal
 *
 * This file is part of Neptus, Command and Control Framework.
 *
 * Commercial Licence Usage
 * Licencees holding valid commercial Neptus licences may use this file
 * in accordance with the commercial licence agreement provided with the
 * Software or, alternatively, in accordance with the terms contained in a
 * written agreement between you and Universidade do Porto. For licensing
 * terms, conditions, and further information contact lsts@fe.up.pt.
 *
 * European Union Public Licence - EUPL v.1.1 Usage
 * Alternatively, this file may be used under the terms of the EUPL,
 * Version 1.1 only (the "Licence"), appearing in the file LICENSE.md
 * included in the packaging of this file. You may not use this work
 * except in compliance with the Licence. Unless required by applicable
 * law or agreed to in writing, software distributed under the Licence is
 * distributed on an "AS IS" basis, WITHOUT WARRANTIES OR CONDITIONS OF
 * ANY KIND, either express or implied. See the Licence for the specific
 * language governing permissions and limitations at
 * https://www.lsts.pt/neptus/licence.
 *
 * For more information please see <http://lsts.fe.up.pt/neptus>.
 *
 * Author: havard
 * Mar 5, 2014
 */
package info.havard.PictureOutlineOnMap;

/**
 * @author havard
 *
 */
public class NED2BODY_RotationMatrix {
    static Matrix NED2BODY(double roll_degrees, double pitch_degrees, double yaw_degrees)
    {
        double roll = Math.toRadians(roll_degrees);
        double pitch = Math.toRadians(pitch_degrees);
        double yaw = Math.toRadians(yaw_degrees);
        
        double sroll = Math.sin(roll);
        double croll = Math.cos(roll);
        double spitch = Math.sin(pitch);
        double cpitch = Math.cos(pitch);
        double syaw = Math.sin(yaw);
        double cyaw = Math.cos(yaw);
        
        double[][] d = {{cpitch*cyaw,-croll*syaw+sroll*spitch*cyaw,sroll*syaw+croll*spitch*cyaw},
                {cpitch*syaw,croll*cyaw+sroll*spitch*syaw,-sroll*cyaw+croll*spitch*syaw},
                {-spitch,sroll*cpitch,croll*cpitch}};
        Matrix T = new Matrix(d);
        
        return T;
    }

}
